const system = require("../../../system");
const Dao = require("../../dao.base");

class LoadDao extends Dao {
    constructor() {
        super(Dao.getModelName(LoadDao));
    }

    async statCount(companyNames, sign_body_id,sign_body) {
        var result = {};

        var sql = "SELECT company_name, COUNT(1) AS num FROM load_info WHERE  1=1";
        if (sign_body_id) {
           sql = sql +" AND sign_body_id = :sign_body_id";
        }
        if (sign_body) {
           sql = sql +" AND sign_body = :sign_body";
        }

        sql = sql +" GROUP BY company_name";

        let list = await this.customQuery(sql, {sign_body_id: sign_body_id,sign_body:sign_body});

        if(!list || list.length == 0) {
            return result;
        }

        for (var item of list) {
            result[item.company_name] = item.num || 0;
        }
        return result;
    }

    async sCount(inno,sign_body_id) {
        var result = {};
        if(!inno || inno.length == 0) {
            return result;
        }
        var sql = "SELECT id_no, COUNT(1) AS num FROM `load_info` WHERE sign_body_id = :sign_body_id AND id_no IN (:inno) GROUP BY id_no";

        let list = await this.customQuery(sql, {inno: inno,sign_body_id:sign_body_id});

        if(!list || list.length == 0) {
            return result;
        }

        for (var item of list) {
            result[item.id_no] = item.num || 0;
        }
        return result;
    }
}

module.exports = LoadDao;
